/*
 * Copyright (c) 2009 by syntevo GmbH. All Rights Reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *  o Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 *  o Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 *  o Neither the name of syntevo GmbH nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package com.syntevo.openapi.smartsvn.command.update;

import com.syntevo.openapi.gui.dialog.*;
import com.syntevo.openapi.smartsvn.command.*;
import com.syntevo.openapi.smartsvn.file.*;

/**
 * Services for {@link com.syntevo.openapi.smartsvn.command.update.IUpdateWorkflow} objects.
 */
public interface UpdateWorkflowServices {

	/**
	 * Returns a {@link com.syntevo.openapi.gui.dialog.DialogDisplayer} to be used the workflow during the configuration phase.
	 * It will display dialogs on top of the update dialog.
	 */
	DialogDisplayer createConfigurationDialogDisplayer();

	/**
	 * Returns a {@link com.syntevo.openapi.gui.dialog.DialogDisplayer} to be used the workflow for the pre-/post-command phase.
	 * It will display dialogs on top of the Project window.
	 */
	DialogDisplayer createPrePostCommandDialogDisplayer();

	/**
	 * Returns an {@link UpdateEntry} object for the specified path and depth.
	 */
	UpdateEntry createUpdateEntry(Path path, SvnDepth depth);
}
