package com.syntevo.plugin.jira.commit.workflow;

import com.syntevo.openapi.smartsvn.command.commit.*;
import com.syntevo.openapi.smartsvn.project.*;

/**
 * @author syntevo GmbH
 */
abstract class FilterCommitPacketPhase implements ICommitPacketPhase {

	// Fields =================================================================

	private final ICommitPacketPhase wrappedPhase;

	// Setup ==================================================================

	protected FilterCommitPacketPhase(ICommitPacketPhase wrappedPhase) {
		if (wrappedPhase == null) {
			throw new IllegalArgumentException("wrappedPhase expected");
		}

		this.wrappedPhase = wrappedPhase;
	}

	// Implemented ============================================================

	public String getID() {
		return wrappedPhase.getID();
	}

	public ICommitPhaseUi getUi() {
		return wrappedPhase.getUi();
	}

	public void initialize(Project project) {
		wrappedPhase.initialize(project);
	}

	public boolean isApplicable(CommitPacketPhaseState state) {
		return wrappedPhase.isApplicable(state);
	}

	public void updateFrom(CommitPacketPhaseState state) {
		wrappedPhase.updateFrom(state);
	}

	public boolean updateTo(CommitPacketPhaseState state) {
		return wrappedPhase.updateTo(state);
	}

	public void beforeShowing() {
		wrappedPhase.beforeShowing();
	}

	public void cleanup(boolean cancelled) {
		wrappedPhase.cleanup(cancelled);
	}
}
